//
//  NavigateViewController.swift
//  AhoyNave-Example
//
//  Created by Syed Ismail Ahamed on 15/05/2022.
//

import UIKit
import AhoyMaps
import CoreLocation

class NavigateViewController: UIViewController {

    @IBOutlet weak var destinationCoordinatesTextField: UITextField!
    @IBOutlet weak var tripidTextField: UITextField!


    override func viewDidLoad() {
        super.viewDidLoad()
    }

    override func viewWillDisappear(_ animated: Bool) {
    }

    @IBAction func navigateToDestinationTapped(_ sender: Any) {

        let tripId = tripidTextField.text ?? ""
        var destinationCoordinates = destinationCoordinatesTextField.text ?? ""


        if tripId.isEmpty && destinationCoordinates.isEmpty {

            let alertVC = UIAlertController(title: "Missing Data", message: "Please enter trip id or destination coordinates", preferredStyle: .alert)
            self.present(alertVC, animated: true, completion: nil)

        } else {
            destinationCoordinates = destinationCoordinates.replacingOccurrences(of: "(", with: "")
                .replacingOccurrences(of: ")", with: "")
                .replacingOccurrences(of: " ", with: "")
            let destinationCoordinatesArray = destinationCoordinates.components(separatedBy: ",")

            if destinationCoordinatesArray.count == 2 {

                if let latitudeString = destinationCoordinatesArray.first,
                   let latitude = Double(latitudeString),
                   let longitudeString = destinationCoordinatesArray.last,
                   let longitude = Double(longitudeString){
                    let destinationLocation = CLLocation(latitude: latitude, longitude: longitude)
                    AhoyMapManager.shared().launchAhoyMaps(destinationLocation: destinationLocation)
                }
            } else if !tripId.isEmpty {

                AhoyMapManager.shared().launchAhoyMaps(tripID: tripId)

            }

        }



    }


}
