//
//  ViewController.swift
//  AhoyMap-Example
//
//  Created by Syed Ismail Ahamed on 14/05/2022.
//

import UIKit
import AhoyMaps

class ViewController: UIViewController {

    @IBOutlet weak var activityIndicator: UIActivityIndicatorView!
    @IBOutlet weak var featureTableView: UITableView!
    var viewModel = ViewModel()
    var ahoyMapView: AhoyMapView?

    override func viewDidLoad() {
        super.viewDidLoad()
        self.title = "Features"
        NotificationCenter.default.addObserver(self, selector: #selector(sdkInitialised), name: Notification.Name.init(rawValue: "SDKInitialised"), object: nil)
        activityIndicator.startAnimating()
    }

    @objc func sdkInitialised() {
        activityIndicator.stopAnimating()
        activityIndicator.isHidden = true

        /*
        If you intend to have Map in your initial view controller then you can do si by adding it as a subview here,This has been commented to test show the map view features table

        ahoyMapView = AhoyMapView()
        ahoyMapView?.frame = self.view.frame
        guard let ahoyMapView = ahoyMapView else {
            return
        }
        featureTableView.isHidden = true
        self.view.addSubview(ahoyMapView)
         */

    }
    
}
extension ViewController : UITableViewDataSource {
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        viewModel.datasource.count
    }

    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        
        let cell: UITableViewCell = {
            guard let cell = tableView.dequeueReusableCell(withIdentifier: "cell") else {
                return UITableViewCell(style: .default, reuseIdentifier: "cell")
            }
            return cell
        }()
        cell.backgroundColor = .clear
        cell.textLabel?.numberOfLines = 0
        cell.textLabel?.textColor = .white
        cell.textLabel?.text = String(describing: viewModel.datasource[indexPath.row].description()).capitalized
        return cell
    }


}

extension ViewController : UITableViewDelegate {
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        let selectedModel = viewModel.datasource[indexPath.row]
        if selectedModel == .navigate {
            navigatetoDestination()
        } else {
            let detailsVC = DetailsViewController(viewModel: DetailsViewModel(feature: selectedModel))
            self.navigationController?.pushViewController(detailsVC, animated: true)
        }
    }
    func navigatetoDestination() {
        let navigateViewController = NavigateViewController()
        self.navigationController?.pushViewController(navigateViewController, animated: true)
    }
}
